﻿Public Class MyProgressBar : Inherits ProgressBar

  Public Delegate Sub SetRefreshCallback()
  Public Delegate Sub SetValueCallback(ByVal v As Integer)

  Public Shadows Text As String = String.Empty

  Public Overloads Property Value() As Integer
    Get
      Return MyBase.Value
    End Get
    Set(ByVal value As Integer)
      If Me.InvokeRequired Then
        Me.Invoke(New SetValueCallback(AddressOf SetValue), New Object() {value})
      Else
        MyBase.Value = value
      End If
    End Set
  End Property

  Private Sub SetValue(ByVal v As Integer)
    MyBase.Value = v
  End Sub

End Class